Loading...
Searching...
No Matches
session

A container of senders and receivers. More...

`#include <session.hpp>`

Inheritance diagram for session:
[legend]
Collaboration diagram for session:
[legend]

## Public Member Functions

| session ()
| Create an empty session.
bool | uninitialized () const
| True if the local end is uninitialized.
bool | active () const
| True if the local end is active.
bool | closed () const
| True if the local and remote ends are closed.
class error_condition | error () const
| Get the error condition of the remote endpoint.
void | open ()
| Open the session.
void | open (const session_options &opts)
| Open the session.
void | close ()
| Close the endpoint.
void | close (const error_condition &)
| Close the endpoint with an error condition.
class container & | container () const
| Get the container for this session.
class work_queue & | work_queue () const
| Get the work_queue for the session.
class connection | connection () const
| Get the connection this session belongs to.
sender | open_sender (const std::string &addr)
| Open a sender for `addr`.
sender | open_sender (const std::string &addr, const sender_options &opts)
| Open a sender for `addr`.
receiver | open_receiver (const std::string &addr)
| Open a receiver for `addr`.
receiver | open_receiver (const std::string &addr, const receiver_options &opts)
| Open a receiver for `addr`.
size_t | incoming_bytes () const
| The number of incoming bytes currently buffered.
size_t | outgoing_bytes () const
| The number of outgoing bytes currently buffered.
sender_range | senders () const
| Return the senders on this session.
receiver_range | receivers () const
| Return the receivers on this session.

## Detailed Description

A container of senders and receivers.

Examples
  broker.cpp.

## Member Function Documentation

## uninitialized()

bool uninitialized | ( |  | ) | const

virtual

True if the local end is uninitialized.

Implements endpoint.

## active()

bool active | ( |  | ) | const

virtual

True if the local end is active.

Implements endpoint.

## closed()

bool closed | ( |  | ) | const

virtual

True if the local and remote ends are closed.

Implements endpoint.

## error()

class error_condition error | ( |  | ) | const

virtual

Get the error condition of the remote endpoint.

Implements endpoint.

## open()

void open | ( | const session_options & | opts | ) |

Open the session.

## close() [1/2]

void close | ( |  | ) |

virtual

Close the endpoint.

Implements endpoint.

## close() [2/2]

void close | ( | const error_condition & |  | ) |

virtual

Close the endpoint with an error condition.

Implements endpoint.

## open_sender()

sender open_sender | ( | const std::string & | addr,
|  | const sender_options & | opts
| ) |  |

Open a sender for `addr`.

## open_receiver()

receiver open_receiver | ( | const std::string & | addr,
|  | const receiver_options & | opts
| ) |  |

Open a receiver for `addr`.

The documentation for this class was generated from the following file:

- proton/session.hpp